=== books/workshops/2003/kaufmann/support/rtl/tool/Makefile ===
include ../../../../../../Makefile-generic
-include Makefile-deps
