=== debian/changelog ===
acl2 (8.3dfsg-2) unstable; urgency=medium

  * certify-books -> regression-fresh
  * debhelper-compat ( = 13 )
  * standards 4.5.0
  * ISO-8859-16 -> UTF-8
  * watch version 4
  * lintian override: rfc2388.txt is not a license file
  * clean books/centaur/vl/kit/test.vlzip books/centaur/getopt/demo2 books/centaur/getopt/demo2-test.ok
  * remove w3 validation in home-page.html

 -- Camm Maguire <camm@debian.org>  Wed, 27 Jan 2021 14:05:42 +0000

acl2 (8.3dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Sat, 22 Aug 2020 14:29:22 +0000
